"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.parseAsReadonlyArray = exports.ReadonlyArrayParser = exports.parseAsMutableArray = exports.MutableArrayParser = void 0;
var abstract_1 = __importDefault(require("../class/abstract"));
var action_1 = require("../function/action");
function parseAsMutableArray(b) {
    return !Array.isArray(b.array)
        ? (0, action_1.determineAction)(b)
        : b.array.map(b.parseElement);
}
exports.parseAsMutableArray = parseAsMutableArray;
function parseAsReadonlyArray(b) {
    return !Array.isArray(b.array)
        ? (0, action_1.determineAction)(b)
        : Object.freeze(b.array.map(b.parseElement));
}
exports.parseAsReadonlyArray = parseAsReadonlyArray;
var ArrayParser = /** @class */ (function (_super) {
    __extends(ArrayParser, _super);
    function ArrayParser(value, parseElement) {
        var _this = _super.call(this, value) || this;
        _this.parseElement = parseElement;
        return _this;
    }
    return ArrayParser;
}(abstract_1["default"]));
var ReadonlyArrayParser = /** @class */ (function (_super) {
    __extends(ReadonlyArrayParser, _super);
    function ReadonlyArrayParser(array, parseElement) {
        var _this = _super.call(this, array, parseElement) || this;
        _this.elseGet = function (alternativeValue) {
            return parseAsReadonlyArray({
                alternativeValue: alternativeValue,
                array: _this.value,
                ifParsingFailThen: 'get',
                parseElement: _this.parseElement
            });
        };
        _this.elseLazyGet = function (alternativeValue) {
            return parseAsReadonlyArray({
                alternativeValue: alternativeValue,
                array: _this.value,
                ifParsingFailThen: 'lazy-get',
                parseElement: _this.parseElement
            });
        };
        _this.elseThrow = function (message) {
            return parseAsReadonlyArray({
                message: message,
                array: _this.value,
                ifParsingFailThen: 'throw',
                parseElement: _this.parseElement
            });
        };
        return _this;
    }
    return ReadonlyArrayParser;
}(ArrayParser));
exports.ReadonlyArrayParser = ReadonlyArrayParser;
var MutableArrayParser = /** @class */ (function (_super) {
    __extends(MutableArrayParser, _super);
    function MutableArrayParser(array, parseElement) {
        var _this = _super.call(this, array, parseElement) || this;
        _this.elseGet = function (alternativeValue) {
            return parseAsMutableArray({
                alternativeValue: alternativeValue,
                array: _this.value,
                ifParsingFailThen: 'get',
                parseElement: _this.parseElement
            });
        };
        _this.elseLazyGet = function (alternativeValue) {
            return parseAsMutableArray({
                alternativeValue: alternativeValue,
                array: _this.value,
                ifParsingFailThen: 'lazy-get',
                parseElement: _this.parseElement
            });
        };
        _this.elseThrow = function (message) {
            return parseAsMutableArray({
                message: message,
                array: _this.value,
                ifParsingFailThen: 'throw',
                parseElement: _this.parseElement
            });
        };
        return _this;
    }
    return MutableArrayParser;
}(ArrayParser));
exports.MutableArrayParser = MutableArrayParser;
//# sourceMappingURL=array.js.map