"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.parseAsReadonlyObject = exports.ReadonlyObjectParser = exports.parseAsMutableObject = exports.MutableObjectParser = void 0;
var abstract_1 = __importDefault(require("../class/abstract"));
var action_1 = require("../function/action");
var isObject = function (o) { return o !== null && typeof o === 'object'; };
function parseAsMutableObject(b) {
    if (isObject(b.object)) {
        return b.parse(b.object);
    }
    return (0, action_1.determineAction)(b);
}
exports.parseAsMutableObject = parseAsMutableObject;
function parseAsReadonlyObject(b) {
    if (isObject(b.object)) {
        return Object.freeze(b.parse(b.object));
    }
    return (0, action_1.determineAction)(b);
}
exports.parseAsReadonlyObject = parseAsReadonlyObject;
var ObjectParser = /** @class */ (function (_super) {
    __extends(ObjectParser, _super);
    function ObjectParser(value, parse) {
        var _this = _super.call(this, value) || this;
        _this.parse = parse;
        return _this;
    }
    return ObjectParser;
}(abstract_1["default"]));
var MutableObjectParser = /** @class */ (function (_super) {
    __extends(MutableObjectParser, _super);
    function MutableObjectParser(object, parse) {
        var _this = _super.call(this, object, parse) || this;
        _this.elseGet = function (alternativeValue) {
            return parseAsMutableObject({
                alternativeValue: alternativeValue,
                parse: _this.parse,
                object: _this.value,
                ifParsingFailThen: 'get'
            });
        };
        _this.elseLazyGet = function (alternativeValue) {
            return parseAsMutableObject({
                alternativeValue: alternativeValue,
                parse: _this.parse,
                object: _this.value,
                ifParsingFailThen: 'lazy-get'
            });
        };
        _this.elseThrow = function (message) {
            return parseAsMutableObject({
                message: message,
                parse: _this.parse,
                object: _this.value,
                ifParsingFailThen: 'throw'
            });
        };
        return _this;
    }
    return MutableObjectParser;
}(ObjectParser));
exports.MutableObjectParser = MutableObjectParser;
var ReadonlyObjectParser = /** @class */ (function (_super) {
    __extends(ReadonlyObjectParser, _super);
    function ReadonlyObjectParser(object, parse) {
        var _this = _super.call(this, object, parse) || this;
        _this.elseGet = function (alternativeValue) {
            return parseAsReadonlyObject({
                alternativeValue: alternativeValue,
                parse: _this.parse,
                object: _this.value,
                ifParsingFailThen: 'get'
            });
        };
        _this.elseLazyGet = function (alternativeValue) {
            return parseAsReadonlyObject({
                alternativeValue: alternativeValue,
                parse: _this.parse,
                object: _this.value,
                ifParsingFailThen: 'lazy-get'
            });
        };
        _this.elseThrow = function (message) {
            return parseAsReadonlyObject({
                message: message,
                parse: _this.parse,
                object: _this.value,
                ifParsingFailThen: 'throw'
            });
        };
        return _this;
    }
    return ReadonlyObjectParser;
}(ObjectParser));
exports.ReadonlyObjectParser = ReadonlyObjectParser;
//# sourceMappingURL=object.js.map