import Parser from '../class/abstract';
import { Get, LazyGet, Throw } from '../function/action';
declare type ObjectOptions<R extends Object> = Readonly<{
    object: unknown;
    parse: (a: any) => R;
}>;
declare function parseAsMutableObject<R extends Object>(p: Throw & ObjectOptions<R>): R;
declare function parseAsMutableObject<R extends Object, T>(p: Get<T> & ObjectOptions<R>): T | R;
declare function parseAsMutableObject<R extends Object, T>(p: LazyGet<T> & ObjectOptions<R>): T | R;
declare function parseAsReadonlyObject<R extends Object>(p: Throw & ObjectOptions<R>): Readonly<R>;
declare function parseAsReadonlyObject<R extends Object, T>(p: Get<T> & ObjectOptions<R>): T | Readonly<R>;
declare function parseAsReadonlyObject<R extends Object, T>(p: LazyGet<T> & ObjectOptions<R>): T | Readonly<R>;
declare type Parse<O extends Object> = ObjectOptions<O>['parse'];
declare abstract class ObjectParser<O extends Object> extends Parser<O> {
    protected readonly parse: Parse<O>;
    constructor(value: any, parse: Parse<O>);
}
declare class MutableObjectParser<O extends Object> extends ObjectParser<O> {
    constructor(object: any, parse: (element: any) => O);
    elseGet: <A>(alternativeValue: A) => O | A;
    elseLazyGet: <A>(alternativeValue: () => A) => O | A;
    elseThrow: (message: string) => O;
}
declare class ReadonlyObjectParser<O extends Object> extends ObjectParser<O> {
    constructor(object: any, parse: (element: any) => O);
    elseGet: <A>(alternativeValue: A) => A | Readonly<O>;
    elseLazyGet: <A>(alternativeValue: () => A) => Readonly<O> | A;
    elseThrow: (message: string) => Readonly<O>;
}
export { MutableObjectParser, parseAsMutableObject, ReadonlyObjectParser, parseAsReadonlyObject, };
