import { StringParser } from '../primitive/string.js';
import { NumberParser } from '../primitive/number.js';
import { BooleanParser } from '../primitive/boolean.js';
import { CustomParser } from '../custom/index.js';
import { NullParser } from '../structure/null.js';
import { MutableArrayParser, ReadonlyArrayParser } from '../structure/array.js';
import { MutableObjectParser, ReadonlyObjectParser } from '../structure/object.js';
class Parser {
    value;
    constructor(value) {
        this.value = value;
    }
    asString = () => new StringParser(this.value);
    asNumber = () => new NumberParser(this.value);
    asBoolean = () => new BooleanParser(this.value);
    asNull = () => new NullParser(this.value);
    asCustom = (predicate) => new CustomParser(this.value, predicate);
    asMutableArray = (parseElement) => new MutableArrayParser(this.value, parseElement);
    asReadonlyArray = (parseElement) => new ReadonlyArrayParser(this.value, parseElement);
    asMutableObject = (parse) => new MutableObjectParser(this.value, parse);
    asReadonlyObject = (parse) => new ReadonlyObjectParser(this.value, parse);
}
const parse = (value) => new Parser(value);
export default parse;
//# sourceMappingURL=index.js.map