import Parser from '../class/abstract.js';
import { determineAction, } from '../function/action.js';
function parseAsCustom(b) {
    return b.predicate(b.value) ? b.value : determineAction(b);
}
class CustomParser extends Parser {
    predicate;
    constructor(value, predicate) {
        super(value);
        this.predicate = predicate;
    }
    elseGet = (alternativeValue) => parseAsCustom({
        alternativeValue,
        value: this.value,
        ifParsingFailThen: 'get',
        predicate: this.predicate,
    });
    elseLazyGet = (alternativeValue) => parseAsCustom({
        alternativeValue,
        value: this.value,
        ifParsingFailThen: 'lazy-get',
        predicate: this.predicate,
    });
    elseThrow = (message) => parseAsCustom({
        message,
        value: this.value,
        predicate: this.predicate,
        ifParsingFailThen: 'throw',
    });
}
export { parseAsCustom, CustomParser };
//# sourceMappingURL=index.js.map