import Parser from '../class/abstract.js';
import { determineAction, } from '../function/action.js';
function parseAsBoolean(b) {
    return typeof b.boolean === 'boolean' ? b.boolean : determineAction(b);
}
class BooleanParser extends Parser {
    constructor(value) {
        super(value);
    }
    elseGet = (alternativeValue) => parseAsBoolean({
        alternativeValue,
        boolean: this.value,
        ifParsingFailThen: 'get',
    });
    elseLazyGet = (alternativeValue) => parseAsBoolean({
        alternativeValue,
        boolean: this.value,
        ifParsingFailThen: 'lazy-get',
    });
    elseThrow = (message) => parseAsBoolean({
        message,
        boolean: this.value,
        ifParsingFailThen: 'throw',
    });
}
export { BooleanParser, parseAsBoolean };
//# sourceMappingURL=boolean.js.map