import Parser from '../class/abstract.js';
import { determineAction, } from '../function/action.js';
import { inRangeOf, isInRangeOf } from '../helper/index.js';
function parseAsString(b) {
    if (typeof b.string !== 'string') {
        return determineAction(b);
    }
    if (!b.numberOfCharactersInRangeOf) {
        return b.string;
    }
    return isInRangeOf({
        ...inRangeOf(b.numberOfCharactersInRangeOf),
        value: b.string.length,
    })
        ? b.string
        : determineAction(b);
}
class StringParser extends Parser {
    range;
    constructor(value) {
        super(value);
    }
    numberOfCharactersInRangeOf = (rangeOf) => {
        this.range = inRangeOf(rangeOf);
        return this;
    };
    elseThrow = (message) => parseAsString({
        message,
        string: this.value,
        ifParsingFailThen: 'throw',
        numberOfCharactersInRangeOf: this.range,
    });
    elseGet = (alternativeValue) => parseAsString({
        alternativeValue,
        string: this.value,
        ifParsingFailThen: 'get',
        numberOfCharactersInRangeOf: this.range,
    });
    elseLazyGet = (alternativeValue) => parseAsString({
        alternativeValue,
        string: this.value,
        ifParsingFailThen: 'lazy-get',
        numberOfCharactersInRangeOf: this.range,
    });
}
export { StringParser, parseAsString };
//# sourceMappingURL=string.js.map